
#define ISAC_MASK 0x20
#define ISAC_ISTA 0x20
#define ISAC_STAR 0x21
#define ISAC_CMDR 0x21
#define ISAC_EXIR 0x24

#define ISAC_RBCH 0x2a

#define ISAC_ADF2 0x39
#define ISAC_SPCR 0x30
#define ISAC_ADF1 0x38
#define ISAC_CIX0 0x31
#define ISAC_STCR 0x37
#define ISAC_MODE 0x22
#define ISAC_RSTA 0x27
#define ISAC_RBCL 0x25
#define ISAC_TIMR 0x23
#define ISAC_SQXR 0x3b

#define HSCX_ISTA 0x20
#define HSCX_CCR1 0x2f
#define HSCX_CCR2 0x2c
#define HSCX_TSAR 0x31
#define HSCX_TSAX 0x30
#define HSCX_XCCR 0x32
#define HSCX_RCCR 0x33
#define HSCX_MODE 0x22
#define HSCX_CMDR 0x21
#define HSCX_EXIR 0x24
#define HSCX_XAD1 0x24
#define HSCX_XAD2 0x25
#define HSCX_RAH2 0x27
#define HSCX_RSTA 0x27
#define HSCX_TIMR 0x23
#define HSCX_STAR 0x21
#define HSCX_RBCL 0x25
#define HSCX_XBCH 0x2d
#define HSCX_VSTR 0x2e
#define HSCX_RLCR 0x2e
#define HSCX_MASK 0x20

#define TYPE_16_0	0x0
#define TYPE_16_3	0x3
#define TYPE_PCC	0x10
#define TYPE_UNKNOWN	0xffff

#define byte unsigned char

struct isachscx {
	char *name;
        byte *membase;
        int iobase;
	int irq;
        int pcc_ctrl;
	int cardtype;
        void (*writeisac)(struct isachscx *,byte off,byte val);
        byte (*readisac)(struct isachscx *,byte off);
        void (*readisac_s)(struct isachscx *,byte *dest,int cnt);
        void (*writeisac_s)(struct isachscx *,byte *src,int cnt);
        void (*writehscx)(struct isachscx *,byte hscx,byte off,byte val);
        byte (*readhscx)(struct isachscx *,byte hscx,byte off);
        void (*readhscx_s)(struct isachscx *,byte hscx,byte *dest,int cnt);
        void (*writehscx_s)(struct isachscx *,byte hscx,byte *src,int cnt);
        void *priv;
};

extern void ih_hscxmode(struct isachscx *ih,int hscx, int mode, int ichan,int chanbits);
extern int ih_checkcard(struct isachscx *ih,int iobase,void *membase,int irq);
extern void ih_initisac(struct isachscx *ih,int iom1_adf1,int iom2_adf1);
extern inline void writehscx(struct isachscx *ih, byte hscx, byte offset,byte data);
extern inline void readhscx_s(struct isachscx *ih, byte hscx, byte * dest, int count);
extern inline void writehscx_s(struct isachscx *ih, byte hscx,byte * src, int count);
extern inline byte readhscx(struct isachscx *ih, byte hscx, byte offset);
extern inline void writeisac(struct isachscx *ih, byte offset, byte value);
extern inline byte readisac(struct isachscx *ih, byte offset);
extern inline void readisac_s(struct isachscx *ih,byte *dest,int cnt);
extern inline void writeisac_s(struct isachscx *ih,byte *src,int cnt);
extern void writehscxCMDR(struct isachscx *ih, int hscx, unsigned char data);



